# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`facter`](#facter): Manage facter

### Defined types

* [`facter::fact`](#facter--fact): Define txt based external facts
* [`facter::structured_data_fact`](#facter--structured_data_fact): Define YAML based external structured data facts.

### Data types

* [`Facter::Conf`](#Facter--Conf)

## Classes

### <a name="facter"></a>`facter`

This class will manage facter and allow you to specify external facts.

#### Parameters

The following parameters are available in the `facter` class:

* [`manage_facts_d_dir`](#-facter--manage_facts_d_dir)
* [`purge_facts_d`](#-facter--purge_facts_d)
* [`facts_d_dir`](#-facter--facts_d_dir)
* [`facts_d_owner`](#-facter--facts_d_owner)
* [`facts_d_group`](#-facter--facts_d_group)
* [`facts_d_mode`](#-facter--facts_d_mode)
* [`path_to_facter`](#-facter--path_to_facter)
* [`path_to_facter_symlink`](#-facter--path_to_facter_symlink)
* [`ensure_facter_symlink`](#-facter--ensure_facter_symlink)
* [`facts_hash`](#-facter--facts_hash)
* [`structured_data_facts_hash`](#-facter--structured_data_facts_hash)
* [`facts_file`](#-facter--facts_file)
* [`facts_file_owner`](#-facter--facts_file_owner)
* [`facts_file_group`](#-facter--facts_file_group)
* [`facts_file_mode`](#-facter--facts_file_mode)
* [`facter_conf_dir`](#-facter--facter_conf_dir)
* [`facter_conf_dir_owner`](#-facter--facter_conf_dir_owner)
* [`facter_conf_dir_group`](#-facter--facter_conf_dir_group)
* [`facter_conf_dir_mode`](#-facter--facter_conf_dir_mode)
* [`facter_conf_name`](#-facter--facter_conf_name)
* [`facter_conf_owner`](#-facter--facter_conf_owner)
* [`facter_conf_group`](#-facter--facter_conf_group)
* [`facter_conf_mode`](#-facter--facter_conf_mode)
* [`facter_conf`](#-facter--facter_conf)

##### <a name="-facter--manage_facts_d_dir"></a>`manage_facts_d_dir`

Data type: `Boolean`

Boolean to determine if the external facts directory will be managed.

Default value: `true`

##### <a name="-facter--purge_facts_d"></a>`purge_facts_d`

Data type: `Boolean`

Boolean to determine if the external facts directory should be purged. This
will remove files not managed by Puppet.

Default value: `false`

##### <a name="-facter--facts_d_dir"></a>`facts_d_dir`

Data type: `Stdlib::Absolutepath`

Path to the directory which will contain the external facts.

Default value: `'/etc/facter/facts.d'`

##### <a name="-facter--facts_d_owner"></a>`facts_d_owner`

Data type: `String[1]`

The owner of the `facts_d_dir`.

Default value: `'root'`

##### <a name="-facter--facts_d_group"></a>`facts_d_group`

Data type: `String[1]`

The group of the `facts_d_dir`.

Default value: `'root'`

##### <a name="-facter--facts_d_mode"></a>`facts_d_mode`

Data type: `Stdlib::Filemode`

The mode of the `facts_d_dir`.

Default value: `'0755'`

##### <a name="-facter--path_to_facter"></a>`path_to_facter`

Data type: `Stdlib::Absolutepath`

The path to the facter binary.

Default value: `'/opt/puppetlabs/bin/facter'`

##### <a name="-facter--path_to_facter_symlink"></a>`path_to_facter_symlink`

Data type: `Stdlib::Absolutepath`

Path to a symlink that points to the facter binary.

Default value: `'/usr/local/bin/facter'`

##### <a name="-facter--ensure_facter_symlink"></a>`ensure_facter_symlink`

Data type: `Boolean`

Boolean to determine if the symlink should be present.

Default value: `false`

##### <a name="-facter--facts_hash"></a>`facts_hash`

Data type: `Hash`

A hash of `facter::fact` entries.

Default value: `{}`

##### <a name="-facter--structured_data_facts_hash"></a>`structured_data_facts_hash`

Data type: `Hash`

A hash of `facter::structured_data_fact` entries.

Default value: `{}`

##### <a name="-facter--facts_file"></a>`facts_file`

Data type: `Pattern[/\.txt*\Z/]`

The file in which the text based external facts are stored. This file must
end with '.txt'.

Default value: `'facts.txt'`

##### <a name="-facter--facts_file_owner"></a>`facts_file_owner`

Data type: `String[1]`

The owner of the facts_file.

Default value: `'root'`

##### <a name="-facter--facts_file_group"></a>`facts_file_group`

Data type: `String[1]`

The group of the facts_file.

Default value: `'root'`

##### <a name="-facter--facts_file_mode"></a>`facts_file_mode`

Data type: `Stdlib::Filemode`

The mode of the facts_file.

Default value: `'0644'`

##### <a name="-facter--facter_conf_dir"></a>`facter_conf_dir`

Data type: `Stdlib::Absolutepath`

The facter configuration directory

Default value: `'/etc/puppetlabs/facter'`

##### <a name="-facter--facter_conf_dir_owner"></a>`facter_conf_dir_owner`

Data type: `String[1]`

The facter configuration directory owner

Default value: `'root'`

##### <a name="-facter--facter_conf_dir_group"></a>`facter_conf_dir_group`

Data type: `String[1]`

The facter configuration directory group owner

Default value: `'root'`

##### <a name="-facter--facter_conf_dir_mode"></a>`facter_conf_dir_mode`

Data type: `Stdlib::Filemode`

The facter configuration directory mode

Default value: `'0755'`

##### <a name="-facter--facter_conf_name"></a>`facter_conf_name`

Data type: `String[1]`

The facter configuration file name

Default value: `'facter.conf'`

##### <a name="-facter--facter_conf_owner"></a>`facter_conf_owner`

Data type: `String[1]`

The facter configuration file name owner

Default value: `'root'`

##### <a name="-facter--facter_conf_group"></a>`facter_conf_group`

Data type: `String[1]`

The facter configuration file name group owner

Default value: `'root'`

##### <a name="-facter--facter_conf_mode"></a>`facter_conf_mode`

Data type: `Stdlib::Filemode`

The facter configuration file name mode

Default value: `'0644'`

##### <a name="-facter--facter_conf"></a>`facter_conf`

Data type: `Facter::Conf`

Hash of facter configurations

Default value: `{}`

## Defined types

### <a name="facter--fact"></a>`facter::fact`

Define txt based external facts

#### Parameters

The following parameters are available in the `facter::fact` defined type:

* [`value`](#-facter--fact--value)
* [`fact`](#-facter--fact--fact)
* [`file`](#-facter--fact--file)
* [`facts_dir`](#-facter--fact--facts_dir)

##### <a name="-facter--fact--value"></a>`value`

Data type: `String[1]`

Value of the fact.

##### <a name="-facter--fact--fact"></a>`fact`

Data type: `String[1]`

Name of the fact

Default value: `$name`

##### <a name="-facter--fact--file"></a>`file`

Data type: `Optional[String[1]]`

File in which the fact will be placed. If not specified, use the default
facts file.

Default value: `undef`

##### <a name="-facter--fact--facts_dir"></a>`facts_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory in which the file will be placed. If not specified, use the
default facts_d_dir.

Default value: `undef`

### <a name="facter--structured_data_fact"></a>`facter::structured_data_fact`

Define YAML based external structured data facts.

#### Parameters

The following parameters are available in the `facter::structured_data_fact` defined type:

* [`data`](#-facter--structured_data_fact--data)
* [`file`](#-facter--structured_data_fact--file)
* [`facts_dir`](#-facter--structured_data_fact--facts_dir)

##### <a name="-facter--structured_data_fact--data"></a>`data`

Data type: `Hash[String[1], Data]`

A hash of facts. All keys must be strings.

##### <a name="-facter--structured_data_fact--file"></a>`file`

Data type: `Pattern[/\.yaml*\Z/]`

File in which the fact will be placed. The file name must end with '.yaml'.

Default value: `'facts.yaml'`

##### <a name="-facter--structured_data_fact--facts_dir"></a>`facts_dir`

Data type: `Optional[Stdlib::Absolutepath]`

Directory in which the file will be placed. If not specified, use the
default facts_d_dir.

Default value: `undef`

## Data types

### <a name="Facter--Conf"></a>`Facter::Conf`

The Facter::Conf data type.

Alias of

```puppet
Struct[{
    'facts'  => Optional[Struct[{
          'blocklist' => Optional[Array[String]],
          'ttls'      => Optional[Array[Hash]]
    }]],
    'global' => Optional[Struct[{
          'external-dir'      => Optional[Array[Stdlib::Absolutepath]],
          'custom-dir'        => Optional[Array[Stdlib::Absolutepath]],
          'no-external-facts' => Optional[Boolean],
          'no-custom-facts'   => Optional[Boolean],
          'no-ruby'           => Optional[Boolean]
    }]],
    'cli'    => Optional[Struct[{
          'debug'     => Optional[Boolean],
          'trace'     => Optional[Boolean],
          'verbose'   => Optional[Boolean],
          'log-level' => Optional[Boolean]
    }]]
}]
```

